#!/usr/local/bin/perl

  # RokuCtrlPerl
  # ver. 0.1
  # Copyright 2008 inutch  http://d.hatena.ne.jp/inutch/
  #
  # This program is free software: you can redistribute it and/or modify
  # it under the terms of the GNU Lesser General Public License as published by
  # the Free Software Foundation, either version 3 of the License, or
  # (at your option) any later version.
  #
  # This program is distributed in the hope that it will be useful,
  # but WITHOUT ANY WARRANTY; without even the implied warranty of
  # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  # GNU Lesser General Public License for more details.
  #
  # You should have received a copy of the GNU Lesser General Public License
  # along with this program.  If not, see <http://www.gnu.org/licenses/>.

use CGI;
use RokuCtrl;

### Connect to Roku
$roku = new RokuCtrl("192.168.1.26", 5555);
$roku->open();

### get CGI paramaters
$q = new CGI;
$mode = $q->param("mode");
if( $mode eq "" ){ $mode = "artist"; }
$artist = uriunesc($q->param("artist"));
$album = uriunesc($q->param("album"));
$number = $q->param("number");

@list;
### dispatch mode
if( $mode eq "artist" ){
	@list = $roku->getartistlist();
	if( not @list ){ @list = $roku->getartistlist(); }
	disp_artist();
}
elsif( $mode eq "album" ){
	@list = $roku->getalbumlist($artist);
	if( not @list ){ @list = $roku->getalbumlist($artist); }
	disp_album();
}
elsif( $mode eq "song" ){
	@list = $roku->getsonglist($artist, $album);
	if( not @list ){ @list = $roku->getsonglist($artist, $album); }
	disp_song();
}
elsif( $mode eq "play" ){
	@list = $roku->filterandplay($artist, $album, $number);
	disp_song();
}
$roku->close();


### HTML header
sub disp_html_head{
  $artist2 = uriesc($artist);
  $album2 = uriesc($album);
  print "Content-type: text/html; charset=UTF-8\n\n";
  print <<"EOM";
<html>
<head>
<title>RokuCtrl</title>
</head>
<body>
<a href="rokuctrl.pl?mode=artist">[Artist]</a> <a href="rokuctrl.pl?mode=album&artist=">[Album]</a><br>
EOM
}

### artist
sub disp_artist{
  disp_html_head();
  print "---Artists---<br>";
  foreach $t_artist (@list){
	$t_artist2 = uriesc($t_artist);
	print <<"EOM";
	<a href="rokuctrl.pl?mode=album&artist=$t_artist2&album=">$t_artist</a>
	[<a href="rokuctrl.pl?mode=play&artist=$t_artist2&album=&number=0">play</a>]<br>
EOM
  }
  disp_html_foot();
}

### album
sub disp_album{
  disp_html_head();
  if( $artist eq ""){ print "---Albums---<br>"; }
  else{ print "---$artist---<br>"; }
  foreach $t_album (@list){
	$t_album2 = uriesc($t_album);
	print <<"EOM";
	<a href="rokuctrl.pl?mode=song&artist=&album=$t_album2&number=0">$t_album</a>
	[<a href="rokuctrl.pl?mode=play&artist=&album=$t_album2&number=0">play</a>]<br>
EOM
  }
  disp_html_foot();
}

### song
sub disp_song{
  disp_html_head();
  print "---$album---<br>";
  my $i=0;
  foreach $t_song (@list){
	print <<"EOM";
	<a href="rokuctrl.pl?mode=play&artist=$artist2&album=$album2&number=$i">$t_song</a><br>
EOM
	$i++;
  }
  disp_html_foot();
}

### HTML footer
sub disp_html_foot{
#  print $debug;
  print <<"EOM";
</body>
</html>
EOM
}

### URI escape
sub uriesc{
  my $str = $_[0];
  $str =~ s/(\W)/'%' . unpack('H2', $1)/eg;
  return ($str);
}

### URI unescape
sub uriunesc{
  my $str = $_[0];
  $str =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack('H2', $1)/eg;
  return ($str);
}
